feat_pos={}
with open('/home/nina/grannot/GrAnnoT/wd/test_data/rice_chr10/nb_genes_chr10.gff3') as gff:
    for line in gff:
        line = line.split()
        feat=line[8].split(";")[0].split("=")[1]
        feat_pos[feat]=[[0,0,0,0],[0,0,0,0]]

# liftoff :
with open('/home/nina/grannot/GrAnnoT/wd/liftoff_chr10_NbToAzu_full.gff','r') as liftoff_gff:
    print("liftoff")
    for line in liftoff_gff:
        if line[0]=="C":
            line=line.split()
            type_feat=line[2]
            if type_feat=="gene":
                start=line[3]
                stop=line[4]
                feat=line[8].split(";")[0].split("=")[1]
                feat_pos[feat][0][0]=(int(start))
                feat_pos[feat][1][0]=(int(stop))

# grannot :
with open('/home/nina/grannot/GrAnnoT/wd/test_data/rice_chr10/test_segcoord/test_mgc/Azucena/Azucena.gff','r') as grannot_gff:
    print("grannot")
    for line in grannot_gff:
        line=line.split()
        start=0;stop=0
        start=line[3]
        stop=line[4]
        feat=line[8].split(";")[0].split("=")[1]
        feat_pos[feat][0][1]=(int(start))
        feat_pos[feat][1][1]=(int(stop))

# odgi : 
with open('/home/nina/soft/odgi_singu/transfer_chr10_genes','r') as odgi_file:
    print("odgi")
    for line in odgi_file:
        line=line.split()
        start=line[4].split(',')[-2]
        stop=line[5].split(',')[-2]
        feat=line[3].split(";")[0].split("=")[1]
        feat_pos[feat][0][2]=(int(start)+1) # +1 because bed format
        feat_pos[feat][1][2]=(int(stop))

# vg :
with open('/home/nina/soft/singularity_vg/nb_genes_chr10_lift_mgc.sam','r') as vg_sam:
    print("vg")
    for line in vg_sam:
        if line[0]!='@':
            line=line.split()
            if line[2]!='*':
                start=line[3]
                length=len(line[9])
                stop=int(start)+length-1
                feat=line[0]
                feat_pos[feat][0][3]=(int(start))
                feat_pos[feat][1][3]=(int(stop))

# compare positions
print("compare positions")
start_comp=[0,0,0,0,0,0,0,0,0,0,0,0] # all common, all but lif, all but gr, all but od, all but vg, lif-gr, lif-od, lif-vg, gr-od, gr-vg, od-vg, no common
stop_comp=[0,0,0,0,0,0,0,0,0,0,0,0] # same as start_comp
all_comp=[0,0,0,0,0,0,0,0,0,0,0,0] # same as start_comp
for feat in feat_pos:
    starts=feat_pos[feat][0]
    stops=feat_pos[feat][1]

    if (len(starts)==4) and (0 not in starts):
        if (starts[0]==starts[1]) and (starts[1]==starts[2]) and (starts[2]==starts[3]):
            start_comp[0]+=1

        if (starts[0]!=starts[1]) and (starts[1]==starts[2]) and (starts[2]==starts[3]):
            start_comp[1]+=1
        if (starts[0]!=starts[1]) and (starts[0]==starts[2]) and (starts[0]==starts[3]):
            start_comp[2]+=1
        if (starts[0]==starts[1]) and (starts[1]!=starts[2]) and (starts[1]==starts[3]):
            start_comp[3]+=1
        if (starts[0]==starts[1]) and (starts[1]==starts[2]) and (starts[2]!=starts[3]):
            start_comp[4]+=1

        if starts[0]==starts[1]:
            start_comp[5]+=1
        if starts[0]==starts[2]:
            start_comp[6]+=1
        if starts[0]==starts[3]:
            start_comp[7]+=1
        if starts[1]==starts[2]:
            start_comp[8]+=1
        if starts[1]==starts[3]:
            start_comp[9]+=1
        if starts[2]==starts[3]:
            start_comp[10]+=1

        if (starts[0]!=starts[1]) and (starts[1]!=starts[2]) and (starts[2]!=starts[3]):
            start_comp[11]+=1

    if (len(stops)==4) and (0 not in stops):
        if (stops[0]==stops[1]) and (stops[1]==stops[2]) and (stops[2]==stops[3]):
            stop_comp[0]+=1

        if (stops[0]!=stops[1]) and (stops[1]==stops[2]) and (stops[2]==stops[3]):
            stop_comp[1]+=1
        if (stops[0]!=stops[1]) and (stops[0]==stops[2]) and (stops[0]==stops[3]):
            stop_comp[2]+=1
        if (stops[0]==stops[1]) and (stops[1]!=stops[2]) and (stops[1]==stops[3]):
            stop_comp[3]+=1
        if (stops[0]==stops[1]) and (stops[1]==stops[2]) and (stops[2]!=stops[3]):
            stop_comp[4]+=1

        if stops[0]==stops[1]:
            stop_comp[5]+=1
        if stops[0]==stops[2]:
            stop_comp[6]+=1
        if stops[0]==stops[3]:
            stop_comp[7]+=1
        if stops[1]==stops[2]:
            stop_comp[8]+=1
        if stops[1]==stops[3]:
            stop_comp[9]+=1
        if stops[2]==stops[3]:
            stop_comp[10]+=1
        
        if (stops[0]!=stops[1]) and (stops[1]!=stops[2]) and (stops[2]!=stops[3]):
            stop_comp[11]+=1


    if (len(stops)==4) and (len(starts)==4) and (0 not in starts) and (0 not in stops):
        if (stops[0]==stops[1]) and (stops[1]==stops[2]) and (stops[2]==stops[3]) and (starts[0]==starts[1]) and (starts[1]==starts[2]) and (starts[2]==starts[3]):
            all_comp[0]+=1

        if (stops[0]!=stops[1]) and (stops[1]==stops[2]) and (stops[2]==stops[3]) and (starts[0]!=starts[1]) and (starts[1]==starts[2]) and (starts[2]==starts[3]):
            all_comp[1]+=1
        if (stops[0]!=stops[1]) and (stops[0]==stops[2]) and (stops[0]==stops[3]) and (starts[0]!=starts[1]) and (starts[0]==starts[2]) and (starts[0]==starts[3]):
            all_comp[2]+=1
        if (stops[0]==stops[1]) and (stops[1]!=stops[2]) and (stops[1]==stops[3]) and (starts[0]==starts[1]) and (starts[1]!=starts[2]) and (starts[1]==starts[3]):
            all_comp[3]+=1
        if (stops[0]==stops[1]) and (stops[1]==stops[2]) and (stops[2]!=stops[3]) and (starts[0]==starts[1]) and (starts[1]==starts[2]) and (starts[2]!=starts[3]):
            all_comp[4]+=1

        if (stops[0]==stops[1]) and (starts[0]==starts[1]):
            all_comp[5]+=1
        if (stops[0]==stops[2]) and (starts[0]==starts[2]):
            all_comp[6]+=1
        if (stops[0]==stops[3]) and (starts[0]==starts[3]):
            all_comp[7]+=1
        if (stops[1]==stops[2]) and (starts[1]==starts[2]):
            all_comp[8]+=1
        if (stops[1]==stops[3]) and (starts[1]==starts[3]):
            all_comp[9]+=1
        if (stops[2]==stops[3]) and (starts[2]==starts[3]):
            all_comp[10]+=1
        
        if (stops[0]!=stops[1]) and (stops[1]!=stops[2]) and (stops[2]!=stops[3]) and (starts[0]!=starts[1]) and (starts[1]!=starts[2]) and (starts[2]!=starts[3]):
            all_comp[11]+=1

print("all common, all but lif, all but gr, all but od, all but vg, lif-gr, lif-od, lif-vg, gr-od, gr-vg, od-vg, no common")
print("start pos",start_comp)
print("stop pos",stop_comp)
print("all comp",all_comp)
